#property copyright "www.forex-station.com"
#property link      "www.forex-station.com"

#property indicator_chart_window

extern ENUM_TIMEFRAMES     timeFrame            = PERIOD_CURRENT;
extern color               LineColor            = clrBlack; 
extern int                 LineStyle            = STYLE_DOT;
extern int                 LineWidth            = 1;
extern string              LinesID              = "DaySeparator";
extern bool                ObjOnBckgrnd         = true;

//template code start1
extern string              ButtonSettings       = "------------------------------";
extern bool                btn_show             = true;                                //btn__show
extern ENUM_BASE_CORNER    btn_corner           = CORNER_LEFT_UPPER; // chart corner for anchoring
extern string              btn_pressed          = "DS on";                     //btn__pressed text
extern string              btn_unpressed        = "DS off";                  //btn__unpressed text
extern int                 btn_offset_x         = 204;                                    //btn__x
extern int                 btn_offset_y         = 20;                                     //btn__y
extern int                 btn_width            = 65;                                 //btn__width
extern int                 btn_height           = 20;                                //btn__height
extern int                 btn_font_size        = 10;                             //btn__font size
input bool                 inpSelection         = false;                      // Highlight to move  
extern color               btn_font_clr         = clrBlack;                      //btn__font color
extern color               btn_bg_color         = clrGray;                         //btn__bg color
extern color               btn_border_clr       = clrWhiteSmoke;               //btn__border color
extern string              note6               = "------------------------------";

string aButtonName = "xyzDaySeparator_button"; 
//template code end1

double dummyBuffer[];
bool returnBars;
string indicatorFileName;

//+------------------------------------------------------------------+
//| Initialization                                                   |
//+------------------------------------------------------------------+

int OnInit()
{

//template code start2  
   if(btn_show){CreateButton();}
   if(!btn_show){ObjectDelete(0,aButtonName);}
//template code end2

   IndicatorBuffers(1);
   SetIndexBuffer  (0,dummyBuffer);
   returnBars        = timeFrame==-99;
   indicatorFileName = WindowExpertName();
   timeFrame         = MathMax(timeFrame,_Period);
   return(0);
   
}
 
//+------------------------------------------------------------------+
//| Deinitialization                                                   |
//+------------------------------------------------------------------+ 
 
int deinit()
{

//template code start3
   ObjectDelete(0,aButtonName);
//template code end3

   int lookForLength = StringLen(LinesID);
      for (int i=ObjectsTotal()-1; i>=0; i--) 
      {
         string name = ObjectName(i);  if (StringSubstr(name,0,lookForLength) == LinesID) ObjectDelete(name);
      }
   return(0); 
}

//+------------------------------------------------------------------+
//| Draw Lines                                                       |
//+------------------------------------------------------------------+  
int start()
{
   int counted_bars = IndicatorCounted();

      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit = MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { dummyBuffer[0] = limit; return(0); }

      if (timeFrame!=_Period) limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,-99,0,0)*timeFrame/Period()));

//template code start4
   if (!ObjectGetInteger(0,aButtonName,OBJPROP_STATE))
      {
//template code end4

         for(int i=limit;i>=0;i--)
         {
            double y = iBarShift(NULL,timeFrame,Time[i]);
            double x = iBarShift(NULL,timeFrame,Time[i+1]);
            string name = LinesID+":"+Time[i];
            ObjectDelete(name);
            if (x!=y)
            {
                  ObjectCreate(name,OBJ_VLINE,0,Time[i],High[i]);
                     ObjectSet(name,OBJPROP_COLOR,LineColor);   // Color value to set/get object color.
                     ObjectSet(name,OBJPROP_STYLE,LineStyle);   // Value is one of STYLE_SOLID, STYLE_DASH, STYLE_DOT, STYLE_DASHDOT, STYLE_DASHDOTDOT constants to set/get object line style.
                     ObjectSet(name,OBJPROP_WIDTH,LineWidth);   // Integer value to set/get object line width. Can be from 1 to 5.
                     ObjectSet(name,OBJPROP_BACK,ObjOnBckgrnd); // Boolean value to set/get background drawing flag for object. (for example "true" will hide the value at the bottom of the chart.)
            }                              
        }
      }
   return(0);
}
//---------------------------------------------------------
//template start codes5
void CreateButton()
{
   ButtonCreate(NULL,aButtonName,0,btn_offset_x,btn_offset_y,btn_width,btn_height,btn_corner,btn_unpressed,"Arial",btn_font_size,btn_font_clr,btn_bg_color,btn_border_clr,false,true,false,false,0);
}
//+------------------------------------------------------------------+
void OnChartEvent(const int id,const long &lparam,const double &dparam,const string &sparam)
{
int i, lookForLength;
string name;
   if (id == CHARTEVENT_OBJECT_CLICK && sparam==aButtonName) 
   { 
      if(ObjectGetInteger (0,aButtonName,OBJPROP_STATE)){
         ObjectSetString  (0,aButtonName,OBJPROP_TEXT,btn_pressed);
         lookForLength = StringLen(LinesID);
         for (i=ObjectsTotal()-1; i>=0; i--) 
             {
              name = ObjectName(i);  
              if (StringSubstr(name,0,lookForLength) == LinesID) 
                  ObjectSet(name, OBJPROP_COLOR, clrNONE);
             }

      }

      if(!ObjectGetInteger(0,aButtonName,OBJPROP_STATE)){
            ObjectSetString  (0,aButtonName,OBJPROP_TEXT,btn_unpressed);

         for (i=ObjectsTotal()-1; i>=0; i--) 
             {
              name = ObjectName(i);  
              if (StringSubstr(name,0,lookForLength) == LinesID) 
                  ObjectCreate(name,OBJ_VLINE,0,Time[i],High[i]);
                  ObjectSet(name, OBJPROP_COLOR, LineColor);
             }
         }
   }
}
//+------------------------------------------------------------------+
bool ButtonCreate(const long              chart_ID   = 0,                                 // chart's ID
                  const string            name       = "Button",                         // button name
                  const int               sub_window = 0,                            // subwindow index
                  const int               x          = 0,                               // X coordinate
                  const int               y          = 0,                               // Y coordinate
                  const int               width      = 50,                              // button width
                  const int               height     = 18,                             // button height
                  const int               mycorner   = CORNER_LEFT_UPPER,
                  const string            text       = "Button",                                // text
                  const string            font       = "Arial",                                 // font
                  const int               font_size  = 10,                                 // font size
                  const color             clr        = clrBlack,                          // text color
                  const color             back_clr   = C'236,233,216',              // background color
                  const color             border_clr = clrNONE,                         // border color
                  const bool              state      = false,                       // pressed/released
                  const bool              back       = false,                      // in the background
                  const bool              selectable = true,                   //object can be selected
                  const bool              selection  = false,                      // highlight to move
                  const bool              hidden     = false,              // hidden in the object list
                  const long              z_order    = 0)                   // priority for mouse click
  {
   ResetLastError();
   ObjectCreate    (chart_ID,name,OBJ_BUTTON,          sub_window,0,0);
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,   x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,   y);
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,       width);
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,      mycorner);
   ObjectSetString (chart_ID,name,OBJPROP_TEXT,        text);
   ObjectSetString (chart_ID,name,OBJPROP_FONT,        font);
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,    font_size);
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,       clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,     back_clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,        back);
   ObjectSetInteger(chart_ID,name,OBJPROP_STATE,       state);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,  selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,    selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,      hidden);
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,      z_order);
   return(true);
  }
//+------------------------------------------------------------------+
//template end codes5
